.686
.model flat,stdcall 
option casemap:none 

include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\user32.inc 

includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib

.data
align 4
  bhold0     dd  8+2 dup (0)  ; the +2 is for overflow/separation
  bhold1     dd  8+2 dup (0)

  btemp2     dd  8+2 dup (0)  ; 256 bits  32 bytes 8 dwords
  wcnt       dd  0
  j          dd  0
  dsc        dd  0   ; decimal string character count  jds
  lpszDec    dd  0

  szDec0     db  "17709198003506581244325443927134847189590119997384300884853802857313414963273",0
             db  0,0
  szDec1     db  "10642745697906047889682877844920059436841133242380302814818302363425481902925",0


.code
start:
  mov lpszDec, offset szDec0

  call DecStrToBin

  mov esi, 9
@@:
  dec esi
  mov eax, [btemp2 + esi*4]
  mov [bhold0 + esi*4], eax
  mov [btemp2 + esi*4], 0
  jnz @B

  mov lpszDec, offset szDec1

  call DecStrToBin

  mov esi, 9
@@:
  dec esi
  mov eax, [btemp2 + esi*4]
  mov [bhold1 + esi*4], eax
  mov [btemp2 + esi*4], 0
  jnz @B

  mov esi, 0
  clc
  mov eax, [bhold0 + esi*4]
  adc [bhold1 + esi*4], eax
  inc esi
  mov eax, [bhold0 + esi*4]
  adc [bhold1 + esi*4], eax
  inc esi
  mov eax, [bhold0 + esi*4]
  adc [bhold1 + esi*4], eax
  inc esi
  mov eax, [bhold0 + esi*4]
  adc [bhold1 + esi*4], eax
  inc esi
  mov eax, [bhold0 + esi*4]
  adc [bhold1 + esi*4], eax
  inc esi
  mov eax, [bhold0 + esi*4]
  adc [bhold1 + esi*4], eax
  inc esi
  mov eax, [bhold0 + esi*4]
  adc [bhold1 + esi*4], eax
  inc esi
  mov eax, [bhold0 + esi*4]
  adc [bhold1 + esi*4], eax
  inc esi
  mov eax, [bhold0 + esi*4]
  adc [bhold1 + esi*4], eax

  Invoke ExitProcess, NULL


; =================== decimal string szDec to binary btemp2 =================================================
DecStrToBin proc

  invoke lstrlen, lpszDec        ;  78 (dec str)  0..77 + 0 byte
  mov dsc, eax
  dec dsc

  mov ecx, lpszDec
  xor eax, eax    ; get first dec char  str(0)
  mov al, [ecx]
  and al, 15
  add btemp2, eax    ; convert and store in lo dword of btemp2 array

  mov wcnt, 1     ; word count 0..1
  mov esi, 1      ; set index to next char  str(1)

  .while (dsc >= esi) ; for each  dec char
     mov eax, esi
     and eax, 3
     .if eax == 0     ; every 8 dec chars uses 2 words
                      ; done to prevent full array width (btemp2) multiply * 10
                      ; only does wcnt words
                      ; it does have a some margin
                      ; really 12 dec chars = 10 hex chars = 5 bytes   hex chars * 1.2 = dec chars
                      ; this   16 dec chars = 16 hex chars = 8 bytes
                      
        cmp wcnt, 15                     ; dwords 0..7   words 0..15
        adc wcnt, 0
     .endif

     xor edx, edx                        ; current dec char  to  dword carry
     mov dl, byte ptr [ecx+esi]
     and dl, 15

     xor edi, edi                        ; mov edi, 0
     .repeat
       xor eax, eax                      ; btemp2 * 10   one word at a time
       mov ax, word ptr [btemp2+edi*2]
       lea eax, [eax*4 + eax]            ; * 5
       add eax, eax                      ; * 2       ; shl eax, 1  is slower
       add eax, edx                      ; + carry  (1st time is dec char)
       mov j, eax
       mov word ptr [btemp2+edi*2], ax   ; store  lo word in btemp2
       mov dx, word ptr j+2              ; carry  hi word
       inc edi
     .until edi > wcnt
     
     inc esi
  .endw
  ret
DecStrToBin endp

end start